#include "interrupts.h"
#include "string.h"
#include "task.h"
#include "types.h"

u16 fork(void)
{
	if (current_task->esp == current_task->esp0 + STACK_SIZE)
		scheduler();
	cli();
	struct task *child = create_task(current_task->uid);
	if (!child)
		return -1;
	child->daddy = current_task;
	current_task->child = child;
	memcpy(child->esp0, current_task->esp0, STACK_SIZE);
	u8 *daddy_esp;
	asm("movl %%esp, %0" : "=m"(daddy_esp));
	child->esp = child->esp0 + (daddy_esp - current_task->esp0);
	toris();
	return current_task == child ? 0 : child->uid;
}
