#include "alloc.h"
#include "debug.h"
#include "interrupts.h"
#include "kprintf.h"
#include "task.h"
#include "time.h"

#include <stddef.h>

struct task *current_task;

void scheduler(void)
{
	cli();
	if (!current_task) // || current_task->next == current_task)
		return;
	struct task *it = current_task->next;
	while (it && it->status != RUN) {
		if (it->status == STOPPED || it->status == ZOMBIE) {
			struct task *new_it = it->prev;
			remove_task(it);
			it = new_it;
		}
		it = it->next;
	}
	switch_to_task(it);
	toris();
}
